# mypy-boto3-rekognition

[![PyPI - mypy-boto3-rekognition](https://img.shields.io/pypi/v/mypy-boto3-rekognition.svg?color=blue)](https://pypi.org/project/mypy-boto3-rekognition)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-rekognition.svg?color=blue)](https://pypi.org/project/mypy-boto3-rekognition)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-rekognition](#mypy-boto3-rekognition)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)

Type annotations for
[boto3.Rekognition 1.13.26](https://boto3.amazonaws.com/v1/documentation/api/1.13.26/reference/services/rekognition.html#Rekognition) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.4](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `Rekognition` service.

```bash
python -m pip install boto3-stubs[rekognition]
```

Use `boto3` with `mypy_boto3_rekognition` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_rekognition import RekognitionClient

# Now mypy can check if your code is valid.
client: RekognitionClient = boto3.client("rekognition")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: RekognitionClient = session.client("rekognition")



# Waiters are also supported

import mypy_boto3_rekognition.waiter as rekognition_waiters

project_version_running_waiter: rekognition_waiters.ProjectVersionRunningWaiter = client.get_waiter("project_version_running")
project_version_training_completed_waiter: rekognition_waiters.ProjectVersionTrainingCompletedWaiter = client.get_waiter("project_version_training_completed")


# Annotated paginators are included as well

import mypy_boto3_rekognition.paginator as rekognition_paginators

describe_project_versions_paginator: rekognition_paginators.DescribeProjectVersionsPaginator = client.get_paginator("describe_project_versions")
describe_projects_paginator: rekognition_paginators.DescribeProjectsPaginator = client.get_paginator("describe_projects")
list_collections_paginator: rekognition_paginators.ListCollectionsPaginator = client.get_paginator("list_collections")
list_faces_paginator: rekognition_paginators.ListFacesPaginator = client.get_paginator("list_faces")
list_stream_processors_paginator: rekognition_paginators.ListStreamProcessorsPaginator = client.get_paginator("list_stream_processors")
```

## Dynamic type annotations

`mypy_boto3` command generates `boto3.client/resource` type annotations for
`mypy_boto3_rekognition` and other installed services.

```bash
# Run this command after you add or remove service packages
python -m mypy_boto3
```

Generated type annotations provide overloads for `boto3.client` and `boto3.resource`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully if you have many services installed
- `VSCode` does not currently support function overloads, use explicit type annotations

```python
import boto3

# Type is discovered correctly by mypy and PyCharm
# VSCode still needs explicit type annotations
client = boto3.client("rekognition")

session_client = boto3.Session().client("rekognition")
```